//FarbSkala_301d.js
// 27.03.11 / Hans Haesler, Chtelard 52, CH-1018 Lausanne / <hsa@ringier.ch>
//DESCRIPTION:Erzeugt eine Farbskala

//// Vorgabe-Einstellungen ////////////////////////////////////////////////////////////////
var yD = 10; // Distanz (in mm) zum oberen Seitenrand
var xD = 10; // Distanz (in mm) zum linken Seitenrand
var nF = 21; // Grenzwert (wenn mehr Kstchen pro Reihe: Dokument versteckt befllen)
//// Vorgabe-Einstellungen ////////////////////////////////////////////////////////////////

// vorsichtshalber die Dialoge einschalten
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// testen, ob ein Dokument geffnet ist
var noDoc = false;
if (app.documents.length == 0) {
	noDoc = true;
}
else {
	// den Dokumentpfad speichern
	var curDoc = app.documents[0];
	try {
		var docFolder = curDoc.filePath;
		var docPath   = curDoc.fullName;
	}
	catch (e) {
		alert ("Das Dokument speichern.", "Achtung");
		exit();
	}
}

// die Funktion aufrufen, welche die gespeicherten Vorgaben einliest
var allPrefs = getPrefs();
if (allPrefs != "") {
	var prefVal = allPrefs.split("\n");
	var cSt   = prefVal[0];
	if (cSt  == "true") { cSt = true; } else { cSt = false; }
	var mSt   = prefVal[1];
	if (mSt  == "true") { mSt = true; } else { mSt = false; }
	var ySt   = prefVal[2];
	if (ySt  == "true") { ySt = true; } else { ySt = false; }
	var kSt   = prefVal[3];
	if (kSt  == "true") { kSt = true; } else { kSt = false; }
	var cFix  = prefVal[4]*1;
	var mFix  = prefVal[5]*1;
	var yFix  = prefVal[6]*1;
	var kFix  = prefVal[7]*1;
	var xVal  = prefVal[8]*1;
	var stVal = prefVal[9]*1;
	var zVal  = prefVal[10]*1;
	var wdVal = prefVal[11]*1;
	var dVal  = prefVal[12]*1;
	var rVal  = prefVal[13];
	var rb01  = 1;
	var rb02  = 0;
	if (rVal == "1") {
		rb01 = 0;
		rb02 = 1;
	}
	var mVal  = prefVal[14];
	var rb03  = 1;
	var rb04  = rb05 = rb06 = 0;
	if (mVal == "1") {
		rb03 = 0;
		rb04 = 1;
	}
	else if (mVal == "2") {
		rb03 = 0;
		rb05 = 1;
	}
	else if (mVal == "3") {
		rb03 = 0;
		rb06 = 1;
	}
}
else {
	// wenn die Prferenzen-Datei nicht gefunden wurde, 
	// auf die folgenden Vorgabenwerte zurckgreifen
	var cFix  =   0;
	var cSt   =   0;
	var mFix  =   0;
	var mSt   =   1;
	var yFix  =   0;
	var ySt   =   0;
	var kFix  =   0;
	var kSt   =   1;
	var xVal  =   0;
	var stVal =   5;
	var zVal  = 100;
	var wdVal =   5;
	var dVal  =   1;
	var rb01  =   1;
	var rb02  =   0;
	var rb03  =   1;
	var rb04  =   0;
	var rb05  =   0;
	var rb06  =   0;
}

// "Gelb" und "Schwarz" bestimmen
if ((app.locale)*1 == 1279477362) { // franzsisches InDesign
	var yChar = "J";
	var kChar = "N";
	var yelloCol = "Jaune";
	var blackCol = "Noir";
}
else if ((app.locale)*1 == 1279477613) { // deutsches InDesign
	var yChar = "Y";
	var kChar = "K";
	var yelloCol = "Gelb";
	var blackCol = "Schwarz";
}
else if ((app.locale)*1 == 1279477102 || (app.locale)*1 == 1279477097) { // englisches InDesign
	var yChar = "Y";
	var kChar = "K";
	var yelloCol = "Yellow";
	var blackCol = "Black";
}
else {
	var yChar = "Y";
	var kChar = "K";
	var yelloCol = "Gelb";
	var blackCol = "Schwarz";
}

// die Funktion aufrufen, welche den Dialog zeigt und auswertet
var anArray = displayDialog();

// den Variablen die zurckerhaltenen Werte zuweisen
var cDec = anArray[0];
var mDec = anArray[1];
var yDec = anArray[2];
var kDec = anArray[3];
var cPc  = anArray[4]*1;
var mPc  = anArray[5]*1;
var yPc  = anArray[6]*1;
var kPc  = anArray[7]*1;
var col1 = anArray[8];
var col2 = anArray[9];
var col3 = anArray[10];
var col4 = anArray[11];
var nFix = anArray[12]*1;
var xPc  = anArray[13]*1;
var sPc  = anArray[14]*1;
var zPc  = anArray[15]*1;
var fW   = anArray[16]*1;
var fH   = fW;
var dV   = anArray[17]*1;
var fDec = anArray[18];
var rDec = anArray[19];

// wenn *kein* fixer Farbanteil gewhlt ist, kann bestimmt werden, 
// welche beiden variablen Farbanteile-Paare bereinandergelegt werden sollen
if (nFix == 0) {
	var bDialog = app.dialogs.add({name:"Farbanteil-Paare bestimmen"});
	with (bDialog) {
		with (dialogColumns.add()) {
			with (dialogRows.add()) {
				with (dialogColumns.add()) {
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"Aus den vier variablen Farbanteilen"});
						staticTexts.add({staticLabel:" "});
					}
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"die beiden bereinanderzulegenden Paare whlen"});
						staticTexts.add({staticLabel:" "});
					}
				}
			}
			with (dialogRows.add()) {
				with (borderPanels.add()) {
					staticTexts.add({staticLabel:" ", minWidth:70});
					with(decButtons = radiobuttonGroups.add()) {
						radiobuttonControls.add({staticLabel:col1 + " + " + col2 + "   |   " + col3 + " + " + col4, checkedState:1});
						radiobuttonControls.add({staticLabel:col1 + " + " + col3 + "   |   " + col2 + " + " + col4, checkedState:0});
						radiobuttonControls.add({staticLabel:col1 + " + " + col4 + "   |   " + col2 + " + " + col3, checkedState:0});
					}
					staticTexts.add({staticLabel:" ", minWidth:40});
				}
			}
		}
	}
	if(bDialog.show() == true) {
		var comDec = decButtons.selectedButton;
		// wenn Button 2 oder 3, die Zuweisung umpolen
		if (comDec == 1) {
			var tmpCol = col3;
			col3 = col2;
			col2 = tmpCol;
		}
		else if (comDec == 2) {
			var tmpCol1 = col2;
			var tmpCol2 = col3;
			col2 = col4;
			col3 = tmpCol1;
			col4 = tmpCol2;
		}
		// den Dialog entfernen
		bDialog.destroy();
	}
	else {
		bDialog.destroy();
		exit();
	}
}
// wenn nur *ein* fixer Farbanteil gewhlt ist, kann bestimmt werden, 
// welche beiden variablen Farbanteile bereinandergelegt werden sollen
else if (nFix == 1) {
	var cDialog = app.dialogs.add({name:"Farbanteil-Paar bestimmen"});
	with (cDialog) {
		with (dialogColumns.add()) {
			with (dialogRows.add()) {
				with (dialogColumns.add()) {
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"Aus den drei variablen Farbanteilen"});
						staticTexts.add({staticLabel:" "});
					}
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"das bereinanderzulegende Paar whlen"});
						staticTexts.add({staticLabel:" "});
					}
				}
			}
			with (dialogRows.add()) {
				with (borderPanels.add()) {
					staticTexts.add({staticLabel:" ", minWidth:70});
					with(decButtons = radiobuttonGroups.add()) {
						radiobuttonControls.add({staticLabel:col2 + " + " + col3, checkedState:1});
						radiobuttonControls.add({staticLabel:col2 + " + " + col4, checkedState:0});
						radiobuttonControls.add({staticLabel:col3 + " + " + col4, checkedState:0});
					}
					staticTexts.add({staticLabel:" ", minWidth:40});
				}
			}
		}
	}
	if(cDialog.show() == true) {
		var comDec = decButtons.selectedButton;
		// wenn Button 2 oder 3, die Zuweisung umpolen
		if (comDec == 1) {
			var tmpCol = col3;
			col3 = col4;
			col4 = tmpCol;
		}
		else if (comDec == 2) {
			var tmpCol = col2;
			col2 = col3;
			col3 = col4;
			col4 = tmpCol;
		}
		// den Dialog entfernen
		cDialog.destroy();
	}
	else {
		cDialog.destroy();
		exit();
	}
}

if (noDoc == false) {
	// die Masseinheiten speichern
	// wenn nicht 2053991795 (= Millimeter), dann auf Millimeter umstellen
	hM = curDoc.viewPreferences.horizontalMeasurementUnits;
	vM = curDoc.viewPreferences.verticalMeasurementUnits;
	if (hM != 2053991795) {
		curDoc.viewPreferences.horizontalMeasurementUnits = MeasurementUnits.millimeters;
	}
	if (vM != 2053991795) {
		curDoc.viewPreferences.verticalMeasurementUnits = MeasurementUnits.millimeters;
	}
	// den Nullpunkt auf Null/Null setzen
	var zP = curDoc.zeroPoint; 
	if (zP != [0,0]) { 
		curDoc.zeroPoint = [0,0]; 
	}
	// die aktive Ebene entsperren (falls notwendig)
	var isLocked = false;
	var curLayer = app.activeWindow.activeLayer;
	if (curLayer.locked) {
		curLayer.locked = false;
		isLocked = true;
	}
}

// die Anzahl Rahmen in einer Reihe ausrechnen
var mN = ((zPc - xPc) + sPc) / sPc;

// wenn Abstand Null, diesen auf -0.1 mm setzen (= bessere Anschlsse am Bildschirm)
if (dV == 0) { dV = -0.1; }

// die Soll-Grsse des Dokuments ausrechnen
var docW = Math.floor((mN * fW) + ((mN-1)*dV) + (xD*2));

if (noDoc) {
	if (docW > 5486.4) {
		var diffVal = docW-5486.4;
		alert ("Die notwendige Dokumentbreite (= " + docW + " mm) \nist " + diffVal + " mm ber dem Maximalwert (= 5486.4 mm). \n\nEntweder kleinere Kstchen oder grsseren Schrittwert.", "Stop");
		exit();
	}
	// ein Dokument erzeugen
	if (mN > nF) { // wenn ber Grenzwert, unsichtbar im Hintergrund
		curDoc = app.documents.add(false, undefined);
	}
	else {
		curDoc = app.documents.add();
	}
	curDoc.viewPreferences.horizontalMeasurementUnits = MeasurementUnits.millimeters;
	curDoc.viewPreferences.verticalMeasurementUnits = MeasurementUnits.millimeters;
	curDoc.documentPreferences.properties = {pageWidth:docW, pageHeight:docW, facingPages:false};
}
else {
	// prfen, ob das Dokument gross genug ist
	var pWidth  = curDoc.documentPreferences.pageWidth;
	var pHeight = curDoc.documentPreferences.pageHeight;
	if (pWidth < (docW-xD) || pHeight < (docW-xD)) {
		alert ("Das Dokument ist zu klein.\n\nEs sollte " + docW + " mm x " + docW + " mm gross sein.", "Stop");
		resetAsBefore();
		exit();
	}
	if (mN > nF) { // wenn Anzahl Kstchen ber dem Grenzwert ...
		// ... das Dokument speichern, schliessen ...
		curDoc.close(SaveOptions.yes);
		// ... und unsichtbar ffnen
		curDoc = app.open(File(docPath), false);
	}
}

// das Auffrischen abstellen ...
if (fDec == 0) {
	app.scriptPreferences.enableRedraw = false;
}
else {
	app.scriptPreferences.enableRedraw = true;
}

// den Variablen c m y k die gewhlten Fix-Werte zuweisen
var c = m = y = k = 0;
if (cDec) { c = cPc; }
if (mDec) { m = mPc; }
if (yDec) { y = yPc; }
if (kDec) { k = kPc; }
// fr die variablen Anteile die Werte um den Schrittwert verringern
if      (col1 == "Cyan")    { c = xPc-sPc; pt1 = 0; }
else if (col1 == "Magenta") { m = xPc-sPc; pt1 = 1; }
else if (col1 == yelloCol)  { y = xPc-sPc; pt1 = 2; }
else if (col1 == blackCol)  { k = xPc-sPc; pt1 = 3; }
if      (col2 == "Cyan")    { c = xPc-sPc; pt2 = 0; }
else if (col2 == "Magenta") { m = xPc-sPc; pt2 = 1; }
else if (col2 == yelloCol)  { y = xPc-sPc; pt2 = 2; }
else if (col2 == blackCol)  { k = xPc-sPc; pt2 = 3; }
if      (col3 == "Cyan")    { c = xPc-sPc; pt3 = 0; }
else if (col3 == "Magenta") { m = xPc-sPc; pt3 = 1; }
else if (col3 == yelloCol)  { y = xPc-sPc; pt3 = 2; }
else if (col3 == blackCol)  { k = xPc-sPc; pt3 = 3; }
if      (col4 == "Cyan")    { c = xPc-sPc; pt4 = 0; }
else if (col4 == "Magenta") { m = xPc-sPc; pt4 = 1; }
else if (col4 == yelloCol)  { y = xPc-sPc; pt4 = 2; }
else if (col4 == blackCol)  { k = xPc-sPc; pt4 = 3; }

// prfen, ob mehr als nur die Grundfarbfelder vorhanden sind
allSwatches = app.documents[0].swatches.everyItem().name;
if (allSwatches.length > 4) {
	makeSure = true;
}
else {
	var makeSure = false;
}

// Versatzwerte und vertikale Startposition vorbereiten
var yOff  = fH+dV;
var xOff  = fW+dV;
var y1    = yD-yOff;

// je nach gewnschter Rckmeldung die Variablen vorbereiten ...
if (rDec == 1) {
	var tenPc   = (mN*mN)/10;
	var testVal = tenPc;
}
// ... oder den Fortschrittsbalken
else if (rDec == 3 && nFix != 3) {
	app.scriptPreferences.enableRedraw = true;
	
	//////////////////  Progressbar  Anfang  //////////////////////////////////////////////////////////////
	
	//------------------------------------------------------------------------------
	// Konstanten
	//------------------------------------------------------------------------------
	// die Anzahl Millisekunden, welche verstreichen sollen, bevor der Fortschrittsbalken geffnet wird
	ProgressBar.openWindowDelay = 150;
	// die Anzahl Millisekunden an Pause, bevor der Fortschrittsbalken aufgefrischt wird
	ProgressBar.updateDelay = 100;
	
	//------------------------------------------------------------------------------
	// Konstruktor
	//------------------------------------------------------------------------------
	function ProgressBar(text, windowtitle, canceltext) {
		this.text = text;
		this.windowtitle = windowtitle;
		this.canceltext = canceltext;
		this.isopen = false;
		this.startTime = new Date().getTime();
		this.lastUpdate = 0;
		this.win = null;
		this.sections = new Array();
		this.progress = 0;
		
		this.newSection(1, text, 1);
		
	} // ProgressBar
	
	//------------------------------------------------------------------------------
	// ProgressBar.prototype.newSection
	// den Fortschrittsbalken unterteilen
	// muss mit einem Aufruf von "sectionCompleted" gekoppelt sein
	// der Titel und "fractionOfParentStep" sind optionelle Argumente
	//------------------------------------------------------------------------------
	ProgressBar.prototype.newSection = function(numSteps, title, fractionOfParentStep) {
		if (fractionOfParentStep == undefined)
			fractionOfParentStep = 1;
		if (title == undefined)
			title = "";
		var numSections = this.sections.length;
		var start = (numSections > 0 ? this.sections[numSections-1].getTotalFractionComplete() : 0);
		var stepFraction = (numSections > 0 ? this.sections[numSections-1].fractionPerStep : 1);
		var newSection = new ProgressSection(title, start, start + (stepFraction * fractionOfParentStep), numSteps, fractionOfParentStep);
		this.sections.push(newSection);
		if (title != "")
			this.updateText(title);
	} // ProgressBar.prototype.newSection
	
	//------------------------------------------------------------------------------
	// ProgressBar.prototype.sectionStepFractionCompleted
	// wird aufgerufen, wenn ein Teil des aktuellen Abschnitts komplett ist
	//------------------------------------------------------------------------------
	ProgressBar.prototype.sectionStepFractionCompleted = function(fraction) {
		var numSections = this.sections.length;
		if (numSections > 0) {
			var section = this.sections[numSections - 1];
			section.stepFractionComplete(fraction);
			this.updateProgress(section.getTotalFractionComplete());
		}
	} // ProgressBar.prototype.sectionStepFractionCompleted
	
	//------------------------------------------------------------------------------
	// ProgressBar.prototype.sectionStepCompleted
	// wird aufgerufen, wenn ein Schritt des aktuellen Abschnitts fertig ist
	//------------------------------------------------------------------------------
	ProgressBar.prototype.sectionStepCompleted = function() {
		var numSections = this.sections.length;
		if (numSections > 0) {
			var section = this.sections[numSections - 1];
			section.stepComplete();
			this.updateProgress(section.getTotalFractionComplete());
		}
	} // ProgressBar.prototype.sectionStepCompleted
	
	//------------------------------------------------------------------------------
	// ProgressBar.prototype.sectionCompleted
	// wird aufgerufen, wenn der aktuelle Abschnitt fertig ist
	//------------------------------------------------------------------------------
	ProgressBar.prototype.sectionCompleted = function() {
		var section = this.sections.pop();
		var numSections = this.sections.length;
		if (numSections > 0) {
			var parent = this.sections[numSections - 1];
			parent.stepFractionComplete(section.fractionOfParent);
			this.updateProgress(parent.getTotalFractionComplete());
			if (parent.title != '' && section.title != '')
				this.updateText(parent.title);
		}
	} // ProgressBar.prototype.sectionCompleted
	
	//------------------------------------------------------------------------------
	// ProgressBar.prototype.close
	//------------------------------------------------------------------------------
		
	ProgressBar.prototype.close = function () {
		if (this.isopen) {
			this.win.close();
			this.isopen = false;
		}
	} // ProgressBar.prototype.close
		
	//------------------------------------------------------------------------------
	// ENDE DES "PUBLIC"-ABSCHNITTES
	//------------------------------------------------------------------------------
	
	//------------------------------------------------------------------------------
	// ProgressBar.prototype.open
	//------------------------------------------------------------------------------
	ProgressBar.prototype.open = function() {
		if (!this.isopen) {
			this.win = new Window('palette', this.windowtitle, undefined, { closeButton: false});
			this.win.main = this.win.add('group',[100,100,480,300]);
			this.win.main.margins = [15,0,15,0];
			this.win.main.orientation = 'column';
			var group = this.win.main.add('group');
			group.orientation = 'column';
			group.alignChildren = ['left', 'fill'];
			this.win.displaytext = group.add('statictext', undefined, this.text);
			this.win.displaytext.preferedSize = [350,60];
			this.win.progressbar = group.add('progressbar', undefined, 0, 1);
			this.win.progressbar.minimumSize.width = 320;
			group.add('statictext', undefined, this.canceltext);
			this.win.layout.layout(true);
			this.win.show();
			this.isopen = true;
		}
	} // ProgressBar.prototype.open
	
	//------------------------------------------------------------------------------
	// ProgressBar.prototype.updateText
	//------------------------------------------------------------------------------
	ProgressBar.prototype.updateText = function(text) {
		if (this.isopen) {
			if (this.text != text) {
				this.win.displaytext.text = text;
			}
		}
		this.text = text;
	} // ProgressBar.prototype.updateText
	
	//------------------------------------------------------------------------------
	// ProgressBar.prototype.updateProgress
	//------------------------------------------------------------------------------
	ProgressBar.prototype.updateProgress = function(progressValue) {
		var now = new Date().getTime();
		if (!this.isopen) {
			if (now - this.startTime >= ProgressBar.openWindowDelay) {
				this.progress = progressValue;
				this.open();
			}
		} else {
			if (progressValue > this.progress) {
				this.progress = progressValue;
				if (now - this.lastUpdate >= ProgressBar.updateDelay) {
					this.lastUpdate = now;
					this.win.progressbar.value = progressValue;
				}
			}
		}
	} // ProgressBar.prototype.updateProgress
	
	//------------------------------------------------------------------------------
	// Definition und Implementierung des ProgressSection-Objekts
	//------------------------------------------------------------------------------
	
	//------------------------------------------------------------------------------
	// Konstruktor
	//------------------------------------------------------------------------------
	function ProgressSection(title, start, end, numSteps, fractionOfParentStep) {
		this.start = start;
		this.end = end;
		this.numSteps = numSteps;
		this.fractionPerStep = (end-start)/numSteps;
		this.stepsComplete = 0;
		this.curStepFractionComplete = 0;
		this.fractionOfParent = fractionOfParentStep;
		this.title = title;
	} // ProgressSection
	
	//------------------------------------------------------------------------------
	// ProgressSection.prototype.stepComplete
	//------------------------------------------------------------------------------
	ProgressSection.prototype.stepComplete = function() {
		this.stepsComplete++;
		this.curStepFractionComplete = 0;
	} // ProgressSection.prototype.stepComplete
	
	//------------------------------------------------------------------------------
	// ProgressSection.prototype.stepFractionComplete
	// ermglicht, einen Teil des aktuellen Abschnitts als komplettiert zu bezeichnen
	//------------------------------------------------------------------------------
	ProgressSection.prototype.stepFractionComplete = function(fraction) {
		this.curStepFractionComplete = fraction;
	} // ProgressSection.prototype.stepFractionComplete
	
	//------------------------------------------------------------------------------
	// ProgressSection.prototype.getTotalFractionComplete
	//------------------------------------------------------------------------------
	ProgressSection.prototype.getTotalFractionComplete = function() {
		return this.start + (this.stepsComplete * this.fractionPerStep) + (this.curStepFractionComplete * this.fractionPerStep);
	} // ProgressSection.prototype.getTotalFractionComplete
	
	//------------------------------------------------------------------------------
	// den Fortschrittsbalken definieren
	//------------------------------------------------------------------------------
	var pbar = new ProgressBar("Vorbereitungen ... ... ... ... ... ... ... ... ... ... ... ... ... ... ...", "Die Farbskala wird erzeugt");
	
	//////////////////  Progressbar  Ende  ////////////////////////////////////////////////////////////////
	
	// den definierten Fortschrittsbalken anzeigen
	pbar.open();
	// die Anzahl Schritte und die Zhlervariable
	var numIterations = (mN*mN);
	var st  = 1;
	var ctr = 0;
}

// eine Schleife durch die Reihen
var ctr = 0;
for (var i=0; i<mN; i++) {
	if (rDec == 3 && nFix != 3) {
		// die Fortschrittsanzeige auffrischen
		pbar.updateText("Reihe " + (i+1) + " (von " + mN + ")  |  Kstchen " + ctr + " (von " + (mN*mN) + ")");
	}
	y1 = y1+yOff; // die vertikale Position der aktuellen Reihe
	x1 = xD;      // der horizontale Startwert fr die Spalte
	if (nFix == 0) {
		// die variablen Werte um den Schrittwert erhhen
		if      (pt1 == 0) { c = c + sPc; }
		else if (pt1 == 1) { m = m + sPc; }
		else if (pt1 == 2) { y = y + sPc; }
		else if (pt1 == 3) { k = k + sPc; }
		if      (pt2 == 0) { c = c + sPc; }
		else if (pt2 == 1) { m = m + sPc; }
		else if (pt2 == 2) { y = y + sPc; }
		else if (pt2 == 3) { k = k + sPc; }
		// die variablen Werte auf den Anfangswert zurcksetzen
		if      (pt3 == 0) { c = xPc; }
		else if (pt3 == 1) { m = xPc; }
		else if (pt3 == 2) { y = xPc; }
		else if (pt3 == 3) { k = xPc; }
		if      (pt4 == 0) { c = xPc; }
		else if (pt4 == 1) { m = xPc; }
		else if (pt4 == 2) { y = xPc; }
		else if (pt4 == 3) { k = xPc; }
	}
	if (nFix == 1) {
		// die variablen Werte um den Schrittwert erhhen
		if      (pt2 == 0) { c = c + sPc; }
		else if (pt2 == 1) { m = m + sPc; }
		else if (pt2 == 2) { y = y + sPc; }
		else if (pt2 == 3) { k = k + sPc; }
		if      (pt3 == 0) { c = c + sPc; }
		else if (pt3 == 1) { m = m + sPc; }
		else if (pt3 == 2) { y = y + sPc; }
		else if (pt3 == 3) { k = k + sPc; }
		// einen variablen Wert auf den Anfangswert zurcksetzen
		if      (pt4 == 0) { c = xPc; }
		else if (pt4 == 1) { m = xPc; }
		else if (pt4 == 2) { y = xPc; }
		else if (pt4 == 3) { k = xPc; }
	}
	else if (nFix == 2) {
		// einen variablen Wert um den Schrittwert erhhen
		if      (pt3 == 0) { c = c + sPc; }
		else if (pt3 == 1) { m = m + sPc; }
		else if (pt3 == 2) { y = y + sPc; }
		else if (pt3 == 3) { k = k + sPc; }
		// einen variablen Wert auf den Anfangswert zurcksetzen
		if      (pt4 == 0) { c = xPc; }
		else if (pt4 == 1) { m = xPc; }
		else if (pt4 == 2) { y = xPc; }
		else if (pt4 == 3) { k = xPc; }
	}
	else if (nFix == 3) {
		// einen variablen Wert auf den Anfangswert zurcksetzen
		if      (pt4 == 0) { c = xPc; }
		else if (pt4 == 1) { m = xPc; }
		else if (pt4 == 2) { y = xPc; }
		else if (pt4 == 3) { k = xPc; }
	}
	// die Farbfelder und Kstchen der aktuellen Reihe erzeugen
	for (var j=0; j<mN; j++) {
		var curValues = [c,m,y,k];
		if (makeSure) {
			var testName = "C=" + c + " M=" + m + " " + yChar + "=" + y + " " + kChar + "=" + k;
			try {
				testColor = curDoc.colors.itemByName(testName).name;
				curColor  = curDoc.colors.itemByName(testName);
			}
			catch (e) {
				curColor  = curDoc.colors.add({colorValue:curValues});
			}
		}
		else {
			curColor = curDoc.colors.add({colorValue:curValues});
		}
		// das aktuelle Kstchen erzeugen
		curDoc.rectangles.add({geometricBounds:[y1,x1,y1+fH,x1+fW], fillColor:curColor, fillTint:100, strokeColor:"None"});
		// die X-Position um den Versatzwert erhhen
		x1 = x1+xOff;
		// 
		if (nFix == 0) {
		// einen variablen Wert um den Schrittwert erhhen
			if      (pt3 == 0) { c = c + sPc; }
			else if (pt3 == 1) { m = m + sPc; }
			else if (pt3 == 2) { y = y + sPc; }
			else if (pt3 == 3) { k = k + sPc; }
		}
		// einen variablen Wert um den Schrittwert erhhen
		if      (pt4 == 0) { c = c + sPc; }
		else if (pt4 == 1) { m = m + sPc; }
		else if (pt4 == 2) { y = y + sPc; }
		else if (pt4 == 3) { k = k + sPc; }
		
		if (rDec == 1) {
			// immer wenn 1 Zehntel der Kstchen erzeugt ist, die Funktion zum Anzeigen aufrufen
			ctr++;
			if (ctr > testVal) {
				showProgress(ctr, mN*mN);
				testVal = testVal+tenPc;
			}
		}
		else if (rDec == 3 && nFix != 3) {
			ctr++;
			// wenn ein Fortschrittsbalken gezeigt werden soll, die Fortschrittsanzeige auffrischen
			pbar.updateText("Reihe " + (i+1) + " (von " + mN + ")  |  Kstchen " + ctr + " (von " + (mN*mN) + ")");
			pbar.sectionStepFractionCompleted(st/numIterations);
			st++;
		}
	}
	// wenn drei fixe Farbanteile, die Ausfhrung nach der ersten Reihe abbrechen
	if (nFix == 3) { break; }
	// wenn nach jeder Reihe rapportiert werden soll, die Funktion zum Anzeigen aufrufen
	if (rDec == 2) {
		if (i < mN-1) {
			showProgress((i+1)*mN, mN*mN);
		}
	}
}

if (rDec == 3 && nFix != 3) {
	// den Fortschrittsbalken schliessen
	pbar.close();
}

// das Dokument sichtbar machen ...
if (mN > nF) {
	curDoc.windows.add();
}

// die Funktion zum Zurcksetzen auf die ursprnglichen Einstellungen aufrufen
resetAsBefore();


////////////////////////////// die Funktionen  ////////////////////////////////////////////

// die Funktion, welche die Informationen vorbereitet
function getPrefs() {
	var allPrefs = "";
	// die Datei lesen, welche die gespeicherten Werte enthlt
	var f = new File("~/Library/Preferences/farbskala301.txt");
	var fileIsOpen = f.open("r");
	if (fileIsOpen) {
		try {
			allPrefs = f.read();
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
	return allPrefs;
}

// den Dialog vorbereiten und anzeigen
function displayDialog() {
	try {
		app.dialogs.everyItem().destroy();
	}
	catch (e) {
	}
	var labelWidth0 =  58;
	var labelWidth1 = 125;
	var labelWidth2 =  75;
	var labelWidth3 = 205;
	var labelWidth4 = 215;
	var fieldWidth  =  32;
	var aDialog = app.dialogs.add({name:"FarbSkala"});
	with (aDialog) {
		with (dialogColumns.add()) {
			with (dialogRows.add()) {
				with (borderPanels.add()) {
					with (dialogColumns.add()) {
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:"Fixe Werte fr die aktivierten Farbanteile"});
							staticTexts.add({staticLabel:" ", minWidth:labelWidth0});
						}
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:" ", minWidth:labelWidth1});
							var cChk = checkboxControls.add({staticLabel:"Cyan",    checkedState:cSt, minWidth:labelWidth2});
							var cVal = integerEditboxes.add({editValue:cFix, minimumValue:0, maximumValue:100, minWidth:fieldWidth});
							staticTexts.add({staticLabel:"%  "});
						}
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:" ", minWidth:labelWidth1});
							var mChk = checkboxControls.add({staticLabel:"Magenta", checkedState:mSt, minWidth:labelWidth2});
							var mVal = integerEditboxes.add({editValue:mFix, minimumValue:0, maximumValue:100, minWidth:fieldWidth});
							staticTexts.add({staticLabel:"%  "});
						}
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:" ", minWidth:labelWidth1});
							var yChk = checkboxControls.add({staticLabel:yelloCol,  checkedState:ySt, minWidth:labelWidth2});
							var yVal = integerEditboxes.add({editValue:yFix, minimumValue:0, maximumValue:100, minWidth:fieldWidth});
							staticTexts.add({staticLabel:"%  "});
						}
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:" ", minWidth:labelWidth1});
							var kChk = checkboxControls.add({staticLabel:blackCol,  checkedState:kSt, minWidth:labelWidth2});
							var kVal = integerEditboxes.add({editValue:kFix, minimumValue:0, maximumValue:100, minWidth:fieldWidth});
							staticTexts.add({staticLabel:"%  "});
						}
					}
				}
			}
			with (dialogRows.add()) {
				with (borderPanels.add()) {
					with (dialogColumns.add()) {
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:"Variable Werte der brigen Farbanteile", minWidth:fieldWidth});
							staticTexts.add({staticLabel:" ", minWidth:40});
						}
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:"Startwert", minWidth:labelWidth3});
							var xValField = realEditboxes.add({editValue:xVal, minimumValue:0, maximumValue:90, minWidth:fieldWidth});
							staticTexts.add({staticLabel:"%  "});
							staticTexts.add({staticLabel:" ", minWidth:10});
						}
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:"Schrittwert", minWidth:labelWidth3});
							var sValField = realEditboxes.add({editValue:stVal, minimumValue:1, maximumValue:25, minWidth:fieldWidth});
							staticTexts.add({staticLabel:"%  "});
						}
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:"Endwert", minWidth:labelWidth3});
							var zValField = realEditboxes.add({editValue:zVal, minimumValue:10, maximumValue:100, minWidth:fieldWidth});
							staticTexts.add({staticLabel:"%  "});
							staticTexts.add({staticLabel:" ", minWidth:10});
						}
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:"(Endwert minus Startwert = Schrittwert-Vielfaches)"});
						}
					}
				}
			}
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:"Kstchenbreite und -hhe", minWidth:labelWidth4});
				var widthField = realEditboxes.add({editValue:wdVal, minimumValue:1, maximumValue:25, minWidth:fieldWidth});
				staticTexts.add({staticLabel:"mm"});
			}
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:"Abstand zw. Reihen und Spalten", minWidth:labelWidth4});
				var distField = realEditboxes.add({editValue:dVal, minimumValue:0, maximumValue:10, minWidth:fieldWidth});
				staticTexts.add({staticLabel:"mm"});
			}
			with (dialogRows.add()) {
				with (borderPanels.add()) {
					staticTexts.add({staticLabel:" ", minWidth:66});
					with(refButtons = radiobuttonGroups.add()) {
						radiobuttonControls.add({staticLabel:"Bildschirm-Auffrischung aus", checkedState:rb01});
						radiobuttonControls.add({staticLabel:"Bildschirm-Auffrischung ein", checkedState:rb02});
					}
					staticTexts.add({staticLabel:" ", minWidth:56});
				}
			}
			with (dialogRows.add()) {
				with (borderPanels.add()) {
					with (dialogColumns.add()) {
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:"Rckmeldungen whrend der Ausfhrung"});
							staticTexts.add({staticLabel:" ", minWidth:53});
						}
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:"", minWidth:66});
							with(msgButtons = radiobuttonGroups.add()) {
								radiobuttonControls.add({staticLabel:"Keine", checkedState:rb03});
								radiobuttonControls.add({staticLabel:"Eine Mitteilung nach jedem Zehntel", checkedState:rb04});
								radiobuttonControls.add({staticLabel:"Eine Mitteilung nach jeder Reihe", checkedState:rb05});
								radiobuttonControls.add({staticLabel:"Ein Fortschrittsbalken", checkedState:rb06});
							}
						}
					}
				}
			}
		}
	}
	if(aDialog.show() == true) {
		var cDec    = cChk.checkedState;
		var cPc     = cVal.editValue;
		var mDec    = mChk.checkedState;
		var mPc     = mVal.editValue;
		var yDec    = yChk.checkedState;
		var yPc     = yVal.editValue;
		var kDec    = kChk.checkedState;
		var kPc     = kVal.editValue;
		var xPc     = xValField.editValue;
		var sPc     = sValField.editValue;
		var zPc     = zValField.editValue;
		var frSize  = widthField.editValue;
		var distVal = distField.editValue;
		var refDec  = refButtons.selectedButton;
		var msgDec  = msgButtons.selectedButton;
		// den Dialog entfernen
		aDialog.destroy();
		// die Liste der Einstellungen ...
		var prefsList = new Array (cDec, mDec, yDec, kDec, cPc, mPc, yPc, kPc, xPc, sPc, zPc, frSize, distVal, refDec, msgDec);
		// ... in eine Textkette verwandeln ...
		var prefString = prefsList.join("\n");
		// ... und zur Funktion schicken, welche sie in eine Datei schreibt
		writeResult(prefString);
		// den Variablen die Wahl des Anwenders zuweisen
		var col1 = col2 = col3 = col4 = "";
		var fixTotal = 0;
		if (cDec) { fixTotal = fixTotal+1; }
		if (mDec) { fixTotal = fixTotal+2; }
		if (yDec) { fixTotal = fixTotal+4; }
		if (kDec) { fixTotal = fixTotal+8; }
		if (fixTotal == 0) {
			var nFix = 0;
			var col1 = "Cyan";
			var col2 = "Magenta";
			var col3 = yelloCol;
			var col4 = blackCol;
		}
		else if (fixTotal == 1) {
			var nFix = 1;
			var col2 = "Magenta";
			var col3 = yelloCol;
			var col4 = blackCol;
		}
		else if (fixTotal == 2) {
			var nFix = 1;
			var col2 = "Cyan";
			var col3 = yelloCol;
			var col4 = blackCol;
		}
		else if (fixTotal == 3) {
			var nFix = 2;
			var col3 = yelloCol;
			var col4 = blackCol;
		}
		else if (fixTotal == 4) {
			var nFix = 1;
			var col2 = "Cyan";
			var col3 = "Magenta";
			var col4 = blackCol;
		}
		else if (fixTotal == 5) {
			var nFix = 2;
			var col3 = "Magenta";
			var col4 = blackCol;
		}
		else if (fixTotal == 6) {
			var nFix = 2;
			var col3 = "Cyan";
			var col4 = blackCol;
		}
		else if (fixTotal == 7) {
			var nFix = 3;
			var col4 = blackCol;
		}
		else if (fixTotal == 8) {
			var nFix = 1;
			var col2 = "Cyan";
			var col3 = "Magenta";
			var col4 = yelloCol;
		}
		else if (fixTotal == 9) {
			var nFix = 2;
			var col3 = "Magenta";
			var col4 = yelloCol;
		}
		else if (fixTotal == 10) {
			var nFix = 2;
			var col3 = "Cyan";
			var col4 = yelloCol;
		}
		else if (fixTotal == 11) {
			var nFix = 3;
			var col4 = yelloCol;
		}
		else if (fixTotal == 12) {
			var nFix = 2;
			var col3 = "Cyan";
			var col4 = "Magenta";
		}
		else if (fixTotal == 13) {
			var nFix = 3;
			var col4 = "Magenta";
		}
		else if (fixTotal == 14) {
			var nFix = 3;
			var col4 = "Cyan";
		}
		else if (fixTotal == 15) {
			alert ("Nicht alle vier Farbanteile als fix whlen.", "Stop");
			exit();
		}
		// die Eingabe testen
		if (xPc != (Math.floor(xPc))) {
			alert ("Startwert: Nur *ganze* Zahlen sind erlaubt.", "Stop");
			exit();
		}
		if (sPc != (Math.floor(sPc))) {
			alert ("Schrittwert: Keine Dezimalstellen, bitte.", "Stop");
			exit();
		}
		if (zPc != (Math.floor(zPc))) {
			alert ("Endwert: Muss eine *ganze* Zahl sein.", "Stop");
			exit();
		}
		if (xPc>zPc) {
			alert ("Der Startwert kann nicht grsser als der Endwert sein.", "Stop");
			exit();
		}
		if ((zPc-xPc)<sPc) {
			alert ("Zwischen Start- und Endwert muss mindestens ein Schrittwert liegen.", "Stop");
			exit();
		}
		if ((zPc-xPc)%sPc != 0) {
			alert ("*Endwert minus Startwert* \nmuss ein Vielfaches des Schrittwertes sein.\n\n( z.B.\nStartwert: " + xPc + " | Endwert: " + (zPc-((zPc-xPc)%sPc)) + "\noder \nStartwert: " + (zPc%sPc) + " | Endwert: " + zPc + " )", "Stop");
			exit();
		}
		return [cDec, mDec, yDec, kDec, cPc, mPc, yPc, kPc, col1, col2, col3, col4, nFix, xPc, sPc, zPc, frSize, distVal, refDec, msgDec];
	}
	else {
		aDialog.destroy();
		exit();
	}
}

// den Anwender ber den aktuellen Stand der Dinge informieren
function showProgress(n, nn) {
	var dlog = new Window("palette");
	dlog.size = [320,100];
	dlog.add("statictext", [80, 100, 320, 116], "Anzahl Kstchen:  " + n + "  (von " + nn + ")");
	dlog.show();
	$.sleep(1000);
	dlog.close(); 
}

// die Einstellungen zurcksetzen
function resetAsBefore() {
	if (noDoc == false) {
		// den Nullpunkt zurcksetzen (falls notwendig) 
		if (zP != [0,0]) { 
			curDoc.zeroPoint = zP; 
		}
		// Masseinheiten zurcksetzen (falls notwendig)
		if (hM != 2053991795) {
			curDoc.viewPreferences.horizontalMeasurementUnits = hM;
		}
		if (vM != 2053991795) {
			curDoc.viewPreferences.verticalMeasurementUnits = vM;
		}
		// die Ebene sperren (falls notwendig)
		if (isLocked) {
			curLayer.locked = true;
		}
	}
	// das Auffrischen aktivieren ...
	app.scriptPreferences.enableRedraw = true;
}

// das Ergebnis in eine Datei schreiben
function writeResult(curPrefs) {
	var f = new File("~/Library/Preferences/farbskala301.txt");
	var fileIsOpen = f.open("w");
	if (fileIsOpen) {
		try {
			f.write(curPrefs);
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
}